// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from audio_msg:msg/AudioFrame.idl
// generated code does not contain a copyright notice
#include "audio_msg/msg/detail/audio_frame__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `pts`
#include "builtin_interfaces/msg/detail/time__functions.h"
// Member `frame_type`
#include "audio_msg/msg/detail/audio_frame_type__functions.h"
// Member `data`
#include "rosidl_runtime_c/primitives_sequence_functions.h"
// Member `smart_audio`
#include "audio_msg/msg/detail/smart_audio_data__functions.h"

bool
audio_msg__msg__AudioFrame__init(audio_msg__msg__AudioFrame * msg)
{
  if (!msg) {
    return false;
  }
  // index
  // pts
  if (!builtin_interfaces__msg__Time__init(&msg->pts)) {
    audio_msg__msg__AudioFrame__fini(msg);
    return false;
  }
  // frame_type
  if (!audio_msg__msg__AudioFrameType__init(&msg->frame_type)) {
    audio_msg__msg__AudioFrame__fini(msg);
    return false;
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__init(&msg->data, 0)) {
    audio_msg__msg__AudioFrame__fini(msg);
    return false;
  }
  // smart_audio
  if (!audio_msg__msg__SmartAudioData__init(&msg->smart_audio)) {
    audio_msg__msg__AudioFrame__fini(msg);
    return false;
  }
  return true;
}

void
audio_msg__msg__AudioFrame__fini(audio_msg__msg__AudioFrame * msg)
{
  if (!msg) {
    return;
  }
  // index
  // pts
  builtin_interfaces__msg__Time__fini(&msg->pts);
  // frame_type
  audio_msg__msg__AudioFrameType__fini(&msg->frame_type);
  // data
  rosidl_runtime_c__uint8__Sequence__fini(&msg->data);
  // smart_audio
  audio_msg__msg__SmartAudioData__fini(&msg->smart_audio);
}

audio_msg__msg__AudioFrame *
audio_msg__msg__AudioFrame__create()
{
  audio_msg__msg__AudioFrame * msg = (audio_msg__msg__AudioFrame *)malloc(sizeof(audio_msg__msg__AudioFrame));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(audio_msg__msg__AudioFrame));
  bool success = audio_msg__msg__AudioFrame__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
audio_msg__msg__AudioFrame__destroy(audio_msg__msg__AudioFrame * msg)
{
  if (msg) {
    audio_msg__msg__AudioFrame__fini(msg);
  }
  free(msg);
}


bool
audio_msg__msg__AudioFrame__Sequence__init(audio_msg__msg__AudioFrame__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  audio_msg__msg__AudioFrame * data = NULL;
  if (size) {
    data = (audio_msg__msg__AudioFrame *)calloc(size, sizeof(audio_msg__msg__AudioFrame));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = audio_msg__msg__AudioFrame__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        audio_msg__msg__AudioFrame__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
audio_msg__msg__AudioFrame__Sequence__fini(audio_msg__msg__AudioFrame__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      audio_msg__msg__AudioFrame__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

audio_msg__msg__AudioFrame__Sequence *
audio_msg__msg__AudioFrame__Sequence__create(size_t size)
{
  audio_msg__msg__AudioFrame__Sequence * array = (audio_msg__msg__AudioFrame__Sequence *)malloc(sizeof(audio_msg__msg__AudioFrame__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = audio_msg__msg__AudioFrame__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
audio_msg__msg__AudioFrame__Sequence__destroy(audio_msg__msg__AudioFrame__Sequence * array)
{
  if (array) {
    audio_msg__msg__AudioFrame__Sequence__fini(array);
  }
  free(array);
}
