// generated from rosidl_generator_c/resource/idl__functions.c.em
// with input from audio_msg:msg/SmartAudioData.idl
// generated code does not contain a copyright notice
#include "audio_msg/msg/detail/smart_audio_data__functions.h"

#include <assert.h>
#include <stdbool.h>
#include <stdlib.h>
#include <string.h>


// Include directives for member types
// Member `frame_type`
#include "audio_msg/msg/detail/smart_audio_frame_type__functions.h"
// Member `event_type`
#include "audio_msg/msg/detail/audio_event_type__functions.h"
// Member `cmd_word`
#include "rosidl_runtime_c/string_functions.h"
// Member `data`
#include "rosidl_runtime_c/primitives_sequence_functions.h"

bool
audio_msg__msg__SmartAudioData__init(audio_msg__msg__SmartAudioData * msg)
{
  if (!msg) {
    return false;
  }
  // frame_type
  if (!audio_msg__msg__SmartAudioFrameType__init(&msg->frame_type)) {
    audio_msg__msg__SmartAudioData__fini(msg);
    return false;
  }
  // event_type
  if (!audio_msg__msg__AudioEventType__init(&msg->event_type)) {
    audio_msg__msg__SmartAudioData__fini(msg);
    return false;
  }
  // cmd_word
  if (!rosidl_runtime_c__String__init(&msg->cmd_word)) {
    audio_msg__msg__SmartAudioData__fini(msg);
    return false;
  }
  // data
  if (!rosidl_runtime_c__uint8__Sequence__init(&msg->data, 0)) {
    audio_msg__msg__SmartAudioData__fini(msg);
    return false;
  }
  // doa_theta
  return true;
}

void
audio_msg__msg__SmartAudioData__fini(audio_msg__msg__SmartAudioData * msg)
{
  if (!msg) {
    return;
  }
  // frame_type
  audio_msg__msg__SmartAudioFrameType__fini(&msg->frame_type);
  // event_type
  audio_msg__msg__AudioEventType__fini(&msg->event_type);
  // cmd_word
  rosidl_runtime_c__String__fini(&msg->cmd_word);
  // data
  rosidl_runtime_c__uint8__Sequence__fini(&msg->data);
  // doa_theta
}

audio_msg__msg__SmartAudioData *
audio_msg__msg__SmartAudioData__create()
{
  audio_msg__msg__SmartAudioData * msg = (audio_msg__msg__SmartAudioData *)malloc(sizeof(audio_msg__msg__SmartAudioData));
  if (!msg) {
    return NULL;
  }
  memset(msg, 0, sizeof(audio_msg__msg__SmartAudioData));
  bool success = audio_msg__msg__SmartAudioData__init(msg);
  if (!success) {
    free(msg);
    return NULL;
  }
  return msg;
}

void
audio_msg__msg__SmartAudioData__destroy(audio_msg__msg__SmartAudioData * msg)
{
  if (msg) {
    audio_msg__msg__SmartAudioData__fini(msg);
  }
  free(msg);
}


bool
audio_msg__msg__SmartAudioData__Sequence__init(audio_msg__msg__SmartAudioData__Sequence * array, size_t size)
{
  if (!array) {
    return false;
  }
  audio_msg__msg__SmartAudioData * data = NULL;
  if (size) {
    data = (audio_msg__msg__SmartAudioData *)calloc(size, sizeof(audio_msg__msg__SmartAudioData));
    if (!data) {
      return false;
    }
    // initialize all array elements
    size_t i;
    for (i = 0; i < size; ++i) {
      bool success = audio_msg__msg__SmartAudioData__init(&data[i]);
      if (!success) {
        break;
      }
    }
    if (i < size) {
      // if initialization failed finalize the already initialized array elements
      for (; i > 0; --i) {
        audio_msg__msg__SmartAudioData__fini(&data[i - 1]);
      }
      free(data);
      return false;
    }
  }
  array->data = data;
  array->size = size;
  array->capacity = size;
  return true;
}

void
audio_msg__msg__SmartAudioData__Sequence__fini(audio_msg__msg__SmartAudioData__Sequence * array)
{
  if (!array) {
    return;
  }
  if (array->data) {
    // ensure that data and capacity values are consistent
    assert(array->capacity > 0);
    // finalize all array elements
    for (size_t i = 0; i < array->capacity; ++i) {
      audio_msg__msg__SmartAudioData__fini(&array->data[i]);
    }
    free(array->data);
    array->data = NULL;
    array->size = 0;
    array->capacity = 0;
  } else {
    // ensure that data, size, and capacity values are consistent
    assert(0 == array->size);
    assert(0 == array->capacity);
  }
}

audio_msg__msg__SmartAudioData__Sequence *
audio_msg__msg__SmartAudioData__Sequence__create(size_t size)
{
  audio_msg__msg__SmartAudioData__Sequence * array = (audio_msg__msg__SmartAudioData__Sequence *)malloc(sizeof(audio_msg__msg__SmartAudioData__Sequence));
  if (!array) {
    return NULL;
  }
  bool success = audio_msg__msg__SmartAudioData__Sequence__init(array, size);
  if (!success) {
    free(array);
    return NULL;
  }
  return array;
}

void
audio_msg__msg__SmartAudioData__Sequence__destroy(audio_msg__msg__SmartAudioData__Sequence * array)
{
  if (array) {
    audio_msg__msg__SmartAudioData__Sequence__fini(array);
  }
  free(array);
}
