// generated from rosidl_generator_c/resource/idl__functions.h.em
// with input from audio_msg:msg/SmartAudioData.idl
// generated code does not contain a copyright notice

#ifndef AUDIO_MSG__MSG__DETAIL__SMART_AUDIO_DATA__FUNCTIONS_H_
#define AUDIO_MSG__MSG__DETAIL__SMART_AUDIO_DATA__FUNCTIONS_H_

#ifdef __cplusplus
extern "C"
{
#endif

#include <stdbool.h>
#include <stdlib.h>

#include "rosidl_runtime_c/visibility_control.h"
#include "audio_msg/msg/rosidl_generator_c__visibility_control.h"

#include "audio_msg/msg/detail/smart_audio_data__struct.h"

/// Initialize msg/SmartAudioData message.
/**
 * If the init function is called twice for the same message without
 * calling fini inbetween previously allocated memory will be leaked.
 * \param[in,out] msg The previously allocated message pointer.
 * Fields without a default value will not be initialized by this function.
 * You might want to call memset(msg, 0, sizeof(
 * audio_msg__msg__SmartAudioData
 * )) before or use
 * audio_msg__msg__SmartAudioData__create()
 * to allocate and initialize the message.
 * \return true if initialization was successful, otherwise false
 */
ROSIDL_GENERATOR_C_PUBLIC_audio_msg
bool
audio_msg__msg__SmartAudioData__init(audio_msg__msg__SmartAudioData * msg);

/// Finalize msg/SmartAudioData message.
/**
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_audio_msg
void
audio_msg__msg__SmartAudioData__fini(audio_msg__msg__SmartAudioData * msg);

/// Create msg/SmartAudioData message.
/**
 * It allocates the memory for the message, sets the memory to zero, and
 * calls
 * audio_msg__msg__SmartAudioData__init().
 * \return The pointer to the initialized message if successful,
 * otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_audio_msg
audio_msg__msg__SmartAudioData *
audio_msg__msg__SmartAudioData__create();

/// Destroy msg/SmartAudioData message.
/**
 * It calls
 * audio_msg__msg__SmartAudioData__fini()
 * and frees the memory of the message.
 * \param[in,out] msg The allocated message pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_audio_msg
void
audio_msg__msg__SmartAudioData__destroy(audio_msg__msg__SmartAudioData * msg);


/// Initialize array of msg/SmartAudioData messages.
/**
 * It allocates the memory for the number of elements and calls
 * audio_msg__msg__SmartAudioData__init()
 * for each element of the array.
 * \param[in,out] array The allocated array pointer.
 * \param[in] size The size / capacity of the array.
 * \return true if initialization was successful, otherwise false
 * If the array pointer is valid and the size is zero it is guaranteed
 # to return true.
 */
ROSIDL_GENERATOR_C_PUBLIC_audio_msg
bool
audio_msg__msg__SmartAudioData__Sequence__init(audio_msg__msg__SmartAudioData__Sequence * array, size_t size);

/// Finalize array of msg/SmartAudioData messages.
/**
 * It calls
 * audio_msg__msg__SmartAudioData__fini()
 * for each element of the array and frees the memory for the number of
 * elements.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_audio_msg
void
audio_msg__msg__SmartAudioData__Sequence__fini(audio_msg__msg__SmartAudioData__Sequence * array);

/// Create array of msg/SmartAudioData messages.
/**
 * It allocates the memory for the array and calls
 * audio_msg__msg__SmartAudioData__Sequence__init().
 * \param[in] size The size / capacity of the array.
 * \return The pointer to the initialized array if successful, otherwise NULL
 */
ROSIDL_GENERATOR_C_PUBLIC_audio_msg
audio_msg__msg__SmartAudioData__Sequence *
audio_msg__msg__SmartAudioData__Sequence__create(size_t size);

/// Destroy array of msg/SmartAudioData messages.
/**
 * It calls
 * audio_msg__msg__SmartAudioData__Sequence__fini()
 * on the array,
 * and frees the memory of the array.
 * \param[in,out] array The initialized array pointer.
 */
ROSIDL_GENERATOR_C_PUBLIC_audio_msg
void
audio_msg__msg__SmartAudioData__Sequence__destroy(audio_msg__msg__SmartAudioData__Sequence * array);

#ifdef __cplusplus
}
#endif

#endif  // AUDIO_MSG__MSG__DETAIL__SMART_AUDIO_DATA__FUNCTIONS_H_
